const canvas = document.querySelector("canvas");
const ctx = canvas.getContext("2d");
const text = document.querySelector(".text");

// Картинки
const bee = new Image();
const bg = new Image();
const fg = new Image();
const blocksUp = new Image();
const blocksBottom = new Image();
const gameOver = new Image();

// Загрузка кртинок
bee.src = "./img/bee.png";
bg.src = "./img/bg.png";
fg.src = "./img/fg.png";
blocksUp.src = "./img/blockU.png";
blocksBottom.src = "./img/blockB.png";
gameOver.src = "./img/over.jpg";

// Позиция пчелки
let xPos = 0;
let yPos = 100;

// Скорость падения
let grav = 1.2;

// Расстояние между препятствиями
let len = 100;

// Счётчик
let score = 0;

//Массив блоков
let blocks = [];

//Нулевой блок
blocks[0] = {
  x: canvas.width,
  y: 0,
};

let draw = () => {
  ctx.drawImage(bg, 0, 0);

  for (let i = 0; i < blocks.length; i++) {
    ctx.drawImage(blocksUp, blocks[i].x, blocks[i].y);
    ctx.drawImage(
      blocksBottom,
      blocks[i].x,
      blocks[i].y + blocksUp.height + len
    );

    blocks[i].x--;

    // Проверка того, что блок пройден
    if (blocks[i].x == 3) {
      score++;
    }

    if (blocks[i].x == 105) {
      blocks.push({
        x: canvas.width,
        y: Math.floor(Math.random() * blocksUp.height) - blocksUp.height,
      });
    }

    if (
      xPos + bee.width >= blocks[i].x &&
      xPos <= blocks[i].x + blocksUp.width &&
      (yPos <= blocks[i].y + blocksUp.height ||
        yPos + bee.height >= blocks[i].y + blocksUp.height + len)
    ) {
      ctx.clearRect(0, 0, 280, 500);
      text.innerHTML += "<h1> Score: " + score + "</h1>";
      ctx.drawImage(gameOver, 0, 0);
      return;
    }
  }

  ctx.drawImage(fg, 0, canvas.height - fg.height);

  ctx.drawImage(bee, xPos, yPos);

  yPos += grav;

  // подсчёт баллов на каждом шаге анимации
  ctx.fillStyle = "#000";
  ctx.font = "14px Vernada";
  ctx.fillText("Score: " + score, 10, canvas.height - 10);

  requestAnimationFrame(draw);
};

//При нажатии на любую кнопку
document.addEventListener(
  "keydown",
  (moveUp = (e) => {
    if (e.keyCode != 13) {
      yPos -= 30;
    }
  })
);

//При нажатии на enter
document.addEventListener(
  "keydown",
  (resert = (e) => {
    if (e.keyCode == 13) {
      location.reload();
    }
  })
);

blocksBottom.onload = draw;